#!/usr/bin/env python
"""
Magic1
by Javantea
June 24, 2012

Trivial magic usage against 10k of a single file. Works better than 
find_compress1.py sadly but happily I now can improve my stuff by adding it as 
a feature. I know that's naughty but I can do it if I feel like =)
Also fuzzing file via ctypes is fun.
file doesn't detect zlib, I wonder why.
From file's man page:
There has been a file command in every UNIX since at least Research Version 4 (man page
dated November, 1973).  The System V version introduced one significant major change: the
external list of magic types.  This slowed the program down slightly but made it a lot
more flexible.

"""
from __future__ import print_function
import magic
import sys

filename = '720p/Survivor01.pkg'
length = 10000

if '-h' in sys.argv:
	print('Usage: magic1.py filename [length]')
	print('length is default 10,000 bytes')
	sys.exit(1)
#end if
if len(sys.argv) > 1:
	filename = sys.argv[1]
#end if
if len(sys.argv) > 2:
	length = int(sys.argv[2])
#end if

m = magic.open(magic.NONE)
m.load()
data = open(filename, 'rb').read(length)
prev_res = None
for i in range(len(data)):
	res = m.buffer(data[i:])
	#print 'result', repr(res)
	#break
	if res != prev_res:
		print('New result', repr(res), 'at', i)
		prev_res = res
	#end if
#next i
print('Done')
